﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace CPCL_Demo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int Result = 0;
            cpcl_dll dll = new cpcl_dll();
            
           

            Result = cpcl_dll.PrinterCreator(ref dll.printer,"HM-A300");
            if (0 == Result)
            {
                Result = cpcl_dll.PortOpen(dll.printer,"USB");
                if (0 == Result)
                {
                    //设置标签大小和打印的数量
                    Result = cpcl_dll.CPCL_AddLabel(dll.printer, 0, 1100, 1);
                    //打印文本
                    Result = cpcl_dll.CPCL_AddText(dll.printer, 0, 7, 2, 10, 10, "你好");
                    Result = cpcl_dll.CPCL_AddText(dll.printer, 0, 7, 2, 90, 10, "hello");
                    Result = cpcl_dll.CPCL_AddText(dll.printer, 0, 7, 2, 10, 40, "こんにちは");
                    //注释条码
                    Result = cpcl_dll.CPCL_AddBarCodeText(dll.printer, 1, 7, 0, 5);
                    //打印Code 128条码
                    Result = cpcl_dll.CPCL_AddBarCode(dll.printer, 0, 0, 1, 1, 50, 10, 80, "123456789");
                    //打印Code 39条码
                    Result = cpcl_dll.CPCL_AddBarCode(dll.printer, 0, 5, 1, 1, 50, 10, 180, "66886868");
                    //打印Code 93条码
                    Result = cpcl_dll.CPCL_AddBarCode(dll.printer, 0, 7, 1, 1, 50, 10, 280, "88886666");
                    //打印EAN 13条码
                    Result = cpcl_dll.CPCL_AddBarCode(dll.printer, 0, 10, 1, 1, 50, 10, 380, "012345678901");
                    //打印EAN 8条码
                    Result = cpcl_dll.CPCL_AddBarCode(dll.printer, 0, 13, 1, 1, 50, 10, 480, "1234567");
                    //打印二维条码
                    Result = cpcl_dll.CPCL_AddQRCode(dll.printer, 0, 10, 580, 2, 6, 1, "1010011110");
                    //打印PDF417二维条码
                    Result = cpcl_dll.CPCL_AddPDF417(dll.printer, 0, 10, 750, 2, 6, 8, 8, 1, "0010101101");
                    //画框
                    Result = cpcl_dll.CPCL_AddBox(dll.printer, 10, 820, 40, 880, 1);
                    //画线
                    Result = cpcl_dll.CPCL_AddLine(dll.printer, 10, 900, 80, 970, 3);
                    //设置打印浓度
                    Result = cpcl_dll.CPCL_SetDensity(dll.printer, 3);
                    //打印标签
                    Result = cpcl_dll.CPCL_Print(dll.printer);
                    //关闭端口
                    Result = cpcl_dll.PortClose(dll.printer);
                    //销毁
                    Result = cpcl_dll.PrinterDestroy(dll.printer);
                }
                else
                {
                    MessageBox.Show("Usb Device not found");
                    return;
                }
            }
            else
            {
                MessageBox.Show("Printer Device not found");
            }
        }
    }

    public class cpcl_dll
    {
        [DllImport("CPCL_SDK")]
        public static extern int PrinterCreator(ref IntPtr printer, string model);

        [DllImport("CPCL_SDK")]
        public static extern IntPtr PrinterCreatorS(string model);

        [DllImport("CPCL_SDK")]
        public static extern int PrinterDestroy(IntPtr printer);

        [DllImport("CPCL_SDK")]
        public static extern int PortOpen(IntPtr printer, string ioSettings);

        [DllImport("CPCL_SDK")]
        public static extern int PortClose(IntPtr printer);

        [DllImport("CPCL_SDK")]
        public static extern int DirectIO(IntPtr printer, byte[] writedata, int wirteNum, byte[] readdata, int readNum, ref int preadedNum);
        
        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddLabel(IntPtr printer, int offSet, int height, int qty);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetAlign(IntPtr printer, int align);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddText(IntPtr printer, int rotate, int fontType, int fontSize, int xPos, int yPos, string data);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddBarCode(IntPtr printer, int rotate, int type, int width, int ratio, int height, int xPos, int yPos, string data);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddBarCodeText(IntPtr printer, int enable, int fontType, int fontSize, int offSet);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddQRCode(IntPtr printer, int rotate, int xPos, int yPos, int model, int unitWidth, int eccLevel, string data);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddPDF417(IntPtr printer, int rotate, int xPos, int yPos, int xDots, int yDots, int columns, int rows, int eccLevel, string data);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddBox(IntPtr printer, int xPos, int yPos, int endXPos, int endYPos, int thickness);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_AddLine(IntPtr printer, int xPos, int yPos, int endXPos, int endYPos, int thickness);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetFontSize(IntPtr printer, int width, int height);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetDensity(IntPtr printer, int density);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetSpeed(IntPtr printer, int speed);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetTextSpacing(IntPtr printer, int Spacing);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetTextBold(IntPtr printer, int bold);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_SetTextUnderline(IntPtr printer, int underline);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_Print(IntPtr printer);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_NextLabelPos(IntPtr printer);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_PreFeed(IntPtr printer, int distance);

        [DllImport("CPCL_SDK")]
        public static extern int CPCL_PostFeed(IntPtr printer, int distance);

        public IntPtr printer;

    }
}


    