﻿Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Runtime.InteropServices
Imports System.Windows.Forms
Imports System.Drawing
Namespace Printer
    Public Class PrinterState
        Public Shared ReadOnly STS_NORMAL As UInteger = &H0
        Public Shared ReadOnly STS_PAPEREMPTY As UInteger = 1
        Public Shared ReadOnly STS_COVEROPEN As UInteger = 2
        Public Shared ReadOnly STS_PAPERNEAREND As UInteger = 4
        Public Shared ReadOnly STS_MSR_READY As UInteger = 8
        Public Shared ReadOnly STS_SMARTCARD_READY As UInteger = 16
        Public Shared ReadOnly STS_ERROR As UInteger = 32
        Public Shared ReadOnly STS_NOT_OPEN As UInteger = 64
        Public Shared ReadOnly STS_OFFLINE As UInteger = 128
        Private m_status As UInteger = 0
        Public Sub New()
            m_status = 0
        End Sub
        Public Property State() As UInteger
            Get
                Return m_status
            End Get
            Set(ByVal value As UInteger)
                m_status = value
            End Set
        End Property
        Public ReadOnly Property IsNormal() As Boolean
            Get
                Return (STS_NORMAL = m_status)
            End Get
        End Property
        Public ReadOnly Property InError() As Boolean
            Get
                Return (PAPEREMPTY OrElse COVEROPEN OrElse PAPERNEAREND OrElse MSR_READY OrElse SMARTCARD_READY OrElse [ERROR] OrElse NOT_OPEN OrElse OFFLINE)
            End Get
        End Property
        Public ReadOnly Property PAPEREMPTY() As Boolean
            Get
                Return ((STS_PAPEREMPTY And m_status) > 0)
            End Get
        End Property
        Public ReadOnly Property COVEROPEN() As Boolean
            Get
                Return ((STS_COVEROPEN And m_status) > 0)
            End Get
        End Property
        Public ReadOnly Property PAPERNEAREND() As Boolean
            Get
                Return ((STS_PAPERNEAREND And m_status) > 0)
            End Get
        End Property
        Public ReadOnly Property MSR_READY() As Boolean
            Get
                Return ((STS_MSR_READY And m_status) > 0)
            End Get
        End Property
        Public ReadOnly Property SMARTCARD_READY() As Boolean
            Get
                Return ((STS_SMARTCARD_READY And m_status) > 0)
            End Get
        End Property
        Public ReadOnly Property [ERROR]() As Boolean
            Get
                Return ((STS_ERROR And m_status) > 0)
            End Get
        End Property
        Public ReadOnly Property NOT_OPEN() As Boolean
            Get
                Return ((STS_NOT_OPEN And m_status) > 0)
            End Get
        End Property
        Public ReadOnly Property OFFLINE() As Boolean
            Get
                Return ((STS_OFFLINE And m_status) > 0)
            End Get
        End Property
    End Class
    Public Class DemoPrinter
        Public Const DLLDIR As String = "CPCL_SDK.dll"
        Public Const charSet As CharSet = CharSet.Ansi
        <DllImport(DLLDIR, charSet:=charSet, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function PrinterCreator(ByRef printer As IntPtr, ByVal model As String) As Integer
        End Function
        <DllImport(DLLDIR, charSet:=charSet, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function PrinterCreatorS(ByVal model As String) As Point
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function PrinterDestroy(ByVal printer As IntPtr) As Integer
        End Function
        <DllImport(DLLDIR, charSet:=charSet, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function PortOpen(ByVal printer As IntPtr, ByVal ioSettings As String) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function PortClose(ByVal printer As IntPtr) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function DirectIO(ByVal printer As IntPtr, ByVal writeData As Byte(), ByVal writenum As Integer, ByVal readData As Byte(), ByVal readNum As Integer, ByRef readedNum As Integer) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_AddLabel(ByVal printer As IntPtr, ByVal offset As Integer, ByVal height As Integer, ByVal qty As Integer) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_SetAlign(ByVal printer As IntPtr, ByVal align As Integer) As Integer
        End Function
        <DllImport(DLLDIR, charSet:=charSet, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_AddText(ByVal printer As IntPtr, ByVal rotate As Integer, ByVal fontType As Integer, ByVal fontSize As Integer, ByVal xPos As Integer, ByVal yPos As Integer, ByVal data As String) As Integer
        End Function
        <DllImport(DLLDIR, charSet:=charSet, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_AddBarCode(ByVal printer As IntPtr, ByVal rotate As Integer, ByVal type As Integer, ByVal width As Integer, ByVal ratio As Integer, ByVal height As Integer, ByVal xpos As Integer, ByVal ypos As Integer, ByVal data As String) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_AddBarCodeText(ByVal printer As IntPtr, ByVal enable As Integer, ByVal fontType As Integer, ByVal fontSize As Integer, ByVal offset As Integer) As Integer
        End Function
        <DllImport(DLLDIR, charSet:=charSet, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_AddQRCode(ByVal printer As IntPtr, ByVal rotate As Integer, ByVal xpos As Integer, ByVal ypos As Integer, ByVal model As Integer, ByVal unitwidth As Integer, ByVal ecclevel As Integer, ByVal data As String) As Integer
        End Function
        <DllImport(DLLDIR, charSet:=charSet, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_AddPDF417(ByVal printer As IntPtr, ByVal rotate As Integer, ByVal xpos As Integer, ByVal ypos As Integer, ByVal xdots As Integer, ByVal ydots As Integer, ByVal columns As Integer, ByVal rows As Integer, ByVal ecclevel As Integer, ByVal data As String) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_AddBox(ByVal printer As IntPtr, ByVal x_pos As Integer, ByVal y_pos As Integer, ByVal xend As Integer, ByVal yend As Integer, ByVal thickness As Integer) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_AddLine(ByVal printer As IntPtr, ByVal x_pos As Integer, ByVal y_pos As Integer, ByVal xend As Integer, ByVal yend As Integer, ByVal thickness As Integer) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_SetFontSize(ByVal printer As IntPtr, ByVal width As Integer, ByVal height As Integer) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_SetDensity(ByVal printer As IntPtr, ByVal density As Integer) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_SetSpeed(ByVal printer As IntPtr, ByVal speed As Integer) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_SetTextSpacing(ByVal printer As IntPtr, ByVal spacing As Integer) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_SetTextBold(ByVal printer As IntPtr, ByVal bold As Integer) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_SetTextUnderline(ByVal printer As IntPtr, ByVal udnderline As Integer) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_Print(ByVal printer As IntPtr) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_NextLabelPos(ByVal printer As IntPtr) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_PreFeed(ByVal printer As IntPtr, ByVal distance As Integer) As Integer
        End Function
        <DllImport(DLLDIR, CallingConvention:=CallingConvention.StdCall)> _
        Private Shared Function CPCL_PostFeed(ByVal printer As IntPtr, ByVal distance As Integer) As Integer
        End Function

        Private printer As IntPtr
        Private langid As Integer = 0
        Private E_SUCCESS As Integer = Constants.E_SUCCESS
        Private E_INVALID_PARAMETER As Integer = Constants.E_INVALID_PARAMETER
        Private state As New PrinterState()
        Private result As Integer = 0
        Public Function DemoPrinterCreator(ByVal model As String) As Integer
            result = PrinterCreator(printer, model)
            Return result
        End Function
        Public Function DemoPortOpen(ByVal ioSettings As String) As Integer
            If printer <> IntPtr.Zero Then
                result = PortOpen(printer, ioSettings)
                Return result
            Else
                Return Constants.E_BAD_HANDLE
            End If
        End Function
        Public Function DemoPrinterDestroy() As Integer
            Return PrinterDestroy(printer)
        End Function
        Public Function DemoPortClose() As Integer
            Return PortClose(printer)
        End Function
        Public Function DemoDirectIO(ByVal writeData As Byte(), ByVal writenum As Integer, ByVal readData As Byte(), ByVal readNum As Integer, ByRef readedNum As Integer) As Integer
            Return DirectIO(printer, writeData, writenum, readData, readNum, readedNum)
        End Function
        Public Function AddLabel(ByVal offset As Integer, ByVal height As Integer, ByVal qty As Integer) As Integer
            Return CPCL_AddLabel(printer, offset, height, qty)
        End Function
        Public Function SetAlign(ByVal align As Integer) As Integer
            Return CPCL_SetAlign(printer, align)
        End Function
        Public Function AddText(ByVal rotate As Integer, ByVal fontType As Integer, ByVal fontSize As Integer, ByVal xPos As Integer, ByVal yPos As Integer, ByVal data As String) As Integer
            Return CPCL_AddText(printer, rotate, fontType, fontSize, xPos, yPos, data)
        End Function
        Public Function AddBarCode(ByVal rotate As Integer, ByVal type As Integer, ByVal width As Integer, ByVal ratio As Integer, ByVal height As Integer, ByVal xpos As Integer, ByVal ypos As Integer, ByVal data As String) As Integer
            Return CPCL_AddBarCode(printer, rotate, type, width, ratio, height, xpos, ypos, data)
        End Function
        Public Function AddBarCodeText(ByVal enable As Integer, ByVal fontType As Integer, ByVal fontSize As Integer, ByVal offset As Integer) As Integer
            Return CPCL_AddBarCodeText(printer, enable, fontType, fontSize, offset)
        End Function
        Public Function AddQRCode(ByVal rotate As Integer, ByVal xpos As Integer, ByVal ypos As Integer, ByVal model As Integer, ByVal unitwidth As Integer, ByVal ecclevel As Integer, ByVal data As String) As Integer
            Return CPCL_AddQRCode(printer, rotate, xpos, ypos, model, unitwidth, ecclevel, data)
        End Function
        Public Function AddPDF417(ByVal rotate As Integer, ByVal xpos As Integer, ByVal ypos As Integer, ByVal xdots As Integer, ByVal ydots As Integer, ByVal columns As Integer, ByVal rows As Integer, ByVal ecclevel As Integer, ByVal data As String) As Integer
            Return CPCL_AddPDF417(printer, rotate, xpos, ypos, xdots, ydots, columns, rows, ecclevel, data)
        End Function
        Public Function AddBox(ByVal x_pos As Integer, ByVal y_pos As Integer, ByVal xend As Integer, ByVal yend As Integer, ByVal thickness As Integer) As Integer
            Return CPCL_AddBox(printer, x_pos, y_pos, xend, yend, thickness)
        End Function
        Public Function AddLine(ByVal x_pos As Integer, ByVal y_pos As Integer, ByVal xend As Integer, ByVal yend As Integer, ByVal thickness As Integer) As Integer
            Return CPCL_AddLine(printer, x_pos, y_pos, xend, yend, thickness)
        End Function
        Public Function SetFontSize(ByVal width As Integer, ByVal height As Integer) As Integer
            Return CPCL_SetFontSize(printer, width, height)
        End Function
        Public Function SetDensity(ByVal density As Integer) As Integer
            Return CPCL_SetDensity(printer, density)
        End Function
        Public Function SetSpeed(ByVal speed As Integer) As Integer
            Return CPCL_SetSpeed(printer, speed)
        End Function
        Public Function SetTextSpacing(ByVal spacing As Integer) As Integer
            Return CPCL_SetTextSpacing(printer, spacing)
        End Function
        Public Function SetTextBold(ByVal bold As Integer) As Integer
            Return CPCL_SetTextBold(printer, bold)
        End Function
        Public Function SetTextUnderline(ByVal udnderline As Integer) As Integer
            Return CPCL_SetTextUnderline(printer, udnderline)
        End Function
        Public Function Print() As Integer
            Return CPCL_Print(printer)
        End Function
        Public Function NextLabelPos() As Integer
            Return CPCL_NextLabelPos(printer)
        End Function
        Public Function PreFeed(ByVal distance As Integer) As Integer
            Return CPCL_PreFeed(printer, distance)
        End Function
        Public Function PostFeed(ByVal distance As Integer) As Integer
            Return CPCL_PostFeed(printer, distance)
        End Function
    End Class
End Namespace

